#Copyright (c) 2018 Vereign AG [https://www.vereign.com]
#
#This is free software: you can redistribute it and/or modify
#it under the terms of the GNU Affero General Public License as
#published by the Free Software Foundation, either version 3 of the
#License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Affero General Public License for more details.
#
#You should have received a copy of the GNU Affero General Public License
#along with this program. If not, see <http://www.gnu.org/licenses/>.

#https://gaiax.vereign.com/tsa/signer/v1/keys
#Author: Georgi Michev georgi.michev@vereign.com

@rest @all @tsa @signer
Feature: API - TSA - Signer keys - v1/keys GET
  As user
  I want to see what keys are available
  So I am able to use them the future

  Background:
    Given we are testing the TSA Signer Api

  Scenario: TSA - Getting all keys from Singer - Positive
    When I get all keys via TSA Signer API
    And the status code should be {200}
    And the response is valid according to the {Signer_GetAllKeys_schema.json} REST schema
    And the field {$..type} has the value {["JsonWebKey2020","JsonWebKey2020"]}
    And the field {$..publicKeyJwk.kid} has the value {["key1","key2"]}
    And the field {$..publicKeyJwk.crv} has the value {["P-256","Ed25519"]}

  Scenario: TSA - Getting key1 from Singer - Positive
    When I get key {key1} via TSA Signer API
    And the status code should be {200}
    And the response is valid according to the {Signer_GetKey_schema.json} REST schema
    And the field {type} has the value {JsonWebKey2020}
    And the field {publicKeyJwk.kid} has the value {key1}
    And the field {publicKeyJwk.crv} has the value {P-256}

  Scenario: TSA - Getting non existing key - Negative
    When I get key {non_existing} via TSA Signer API
    And the response is valid according to the {Signer_GetKey_negative_schema.json} REST schema
    And the status code should be {404}
